--- old/grub/include/grub/zfs/zfs.h	2012-08-31 05:08:57.526925138 +0400
+++ new/grub/include/grub/zfs/zfs.h	2012-08-31 05:08:57.561499945 +0400
@@ -18,6 +18,9 @@
  /*
   * Copyright (c) 2007, 2010, Oracle and/or its affiliates. All rights reserved.
   */
+/*
+ *  Copyright 2012, Daniil Lunev
+ */
 
 #ifndef	GRUB_ZFS_HEADER
 #define	GRUB_ZFS_HEADER 1
@@ -37,6 +40,7 @@
  * On-disk version number.
  */
 #define	SPA_VERSION			33ULL
+#define	SPA_FEATURE_VERSION		5000ULL
 
 /*
  * The following are configuration names used in the nvlist describing a pool's
@@ -134,6 +138,8 @@
 		  grub_size_t keylen,
 		  int passphrase);
 
+grub_err_t
+get_default_bootfs_obj(grub_device_t dev, char * path, grub_uint64_t * mdnobj);
 extern grub_err_t (*grub_zfs_decrypt) (grub_crypto_cipher_handle_t cipher,
 				       grub_uint64_t algo,
 				       void *nonce,
